// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from acoustic_msgs:msg/AhoiPacket.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/ahoi_packet.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__STRUCT_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__acoustic_msgs__msg__AhoiPacket __attribute__((deprecated))
#else
# define DEPRECATED__acoustic_msgs__msg__AhoiPacket __declspec(deprecated)
#endif

namespace acoustic_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AhoiPacket_
{
  using Type = AhoiPacket_<ContainerAllocator>;

  explicit AhoiPacket_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->src = 0;
      this->dst = 0;
      this->type = 0;
      this->status = 0;
      this->dsn = 0;
      this->len = 0;
    }
  }

  explicit AhoiPacket_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->src = 0;
      this->dst = 0;
      this->type = 0;
      this->status = 0;
      this->dsn = 0;
      this->len = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _src_type =
    uint8_t;
  _src_type src;
  using _dst_type =
    uint8_t;
  _dst_type dst;
  using _type_type =
    uint8_t;
  _type_type type;
  using _status_type =
    uint8_t;
  _status_type status;
  using _dsn_type =
    uint8_t;
  _dsn_type dsn;
  using _len_type =
    uint8_t;
  _len_type len;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__src(
    const uint8_t & _arg)
  {
    this->src = _arg;
    return *this;
  }
  Type & set__dst(
    const uint8_t & _arg)
  {
    this->dst = _arg;
    return *this;
  }
  Type & set__type(
    const uint8_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__dsn(
    const uint8_t & _arg)
  {
    this->dsn = _arg;
    return *this;
  }
  Type & set__len(
    const uint8_t & _arg)
  {
    this->len = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> *;
  using ConstRawPtr =
    const acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__acoustic_msgs__msg__AhoiPacket
    std::shared_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__acoustic_msgs__msg__AhoiPacket
    std::shared_ptr<acoustic_msgs::msg::AhoiPacket_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AhoiPacket_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->src != other.src) {
      return false;
    }
    if (this->dst != other.dst) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->dsn != other.dsn) {
      return false;
    }
    if (this->len != other.len) {
      return false;
    }
    return true;
  }
  bool operator!=(const AhoiPacket_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AhoiPacket_

// alias to use template instance with default allocator
using AhoiPacket =
  acoustic_msgs::msg::AhoiPacket_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace acoustic_msgs

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__STRUCT_HPP_
