// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from acoustic_msgs:msg/AhoiPacket.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/ahoi_packet.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__TRAITS_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "acoustic_msgs/msg/detail/ahoi_packet__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace acoustic_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AhoiPacket & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: src
  {
    out << "src: ";
    rosidl_generator_traits::value_to_yaml(msg.src, out);
    out << ", ";
  }

  // member: dst
  {
    out << "dst: ";
    rosidl_generator_traits::value_to_yaml(msg.dst, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: dsn
  {
    out << "dsn: ";
    rosidl_generator_traits::value_to_yaml(msg.dsn, out);
    out << ", ";
  }

  // member: len
  {
    out << "len: ";
    rosidl_generator_traits::value_to_yaml(msg.len, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AhoiPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: src
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src: ";
    rosidl_generator_traits::value_to_yaml(msg.src, out);
    out << "\n";
  }

  // member: dst
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dst: ";
    rosidl_generator_traits::value_to_yaml(msg.dst, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: dsn
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dsn: ";
    rosidl_generator_traits::value_to_yaml(msg.dsn, out);
    out << "\n";
  }

  // member: len
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "len: ";
    rosidl_generator_traits::value_to_yaml(msg.len, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AhoiPacket & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace acoustic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use acoustic_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const acoustic_msgs::msg::AhoiPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  acoustic_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use acoustic_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const acoustic_msgs::msg::AhoiPacket & msg)
{
  return acoustic_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<acoustic_msgs::msg::AhoiPacket>()
{
  return "acoustic_msgs::msg::AhoiPacket";
}

template<>
inline const char * name<acoustic_msgs::msg::AhoiPacket>()
{
  return "acoustic_msgs/msg/AhoiPacket";
}

template<>
struct has_fixed_size<acoustic_msgs::msg::AhoiPacket>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<acoustic_msgs::msg::AhoiPacket>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<acoustic_msgs::msg::AhoiPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__AHOI_PACKET__TRAITS_HPP_
