// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from acoustic_msgs:msg/AnchorPose.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/anchor_pose.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__STRUCT_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__acoustic_msgs__msg__AnchorPose __attribute__((deprecated))
#else
# define DEPRECATED__acoustic_msgs__msg__AnchorPose __declspec(deprecated)
#endif

namespace acoustic_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AnchorPose_
{
  using Type = AnchorPose_<ContainerAllocator>;

  explicit AnchorPose_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  explicit AnchorPose_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    acoustic_msgs::msg::AnchorPose_<ContainerAllocator> *;
  using ConstRawPtr =
    const acoustic_msgs::msg::AnchorPose_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::AnchorPose_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::AnchorPose_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__acoustic_msgs__msg__AnchorPose
    std::shared_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__acoustic_msgs__msg__AnchorPose
    std::shared_ptr<acoustic_msgs::msg::AnchorPose_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AnchorPose_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const AnchorPose_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AnchorPose_

// alias to use template instance with default allocator
using AnchorPose =
  acoustic_msgs::msg::AnchorPose_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace acoustic_msgs

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__STRUCT_HPP_
