// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from acoustic_msgs:msg/AnchorPose.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/anchor_pose.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__TRAITS_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "acoustic_msgs/msg/detail/anchor_pose__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace acoustic_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AnchorPose & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AnchorPose & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AnchorPose & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace acoustic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use acoustic_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const acoustic_msgs::msg::AnchorPose & msg,
  std::ostream & out, size_t indentation = 0)
{
  acoustic_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use acoustic_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const acoustic_msgs::msg::AnchorPose & msg)
{
  return acoustic_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<acoustic_msgs::msg::AnchorPose>()
{
  return "acoustic_msgs::msg::AnchorPose";
}

template<>
inline const char * name<acoustic_msgs::msg::AnchorPose>()
{
  return "acoustic_msgs/msg/AnchorPose";
}

template<>
struct has_fixed_size<acoustic_msgs::msg::AnchorPose>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct has_bounded_size<acoustic_msgs::msg::AnchorPose>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct is_message<acoustic_msgs::msg::AnchorPose>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSE__TRAITS_HPP_
