// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from acoustic_msgs:msg/DistanceTOF.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/distance_tof.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__STRUCT_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__acoustic_msgs__msg__DistanceTOF __attribute__((deprecated))
#else
# define DEPRECATED__acoustic_msgs__msg__DistanceTOF __declspec(deprecated)
#endif

namespace acoustic_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DistanceTOF_
{
  using Type = DistanceTOF_<ContainerAllocator>;

  explicit DistanceTOF_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance = 0.0;
      this->tof = 0.0;
    }
  }

  explicit DistanceTOF_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance = 0.0;
      this->tof = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _distance_type =
    double;
  _distance_type distance;
  using _tof_type =
    double;
  _tof_type tof;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__distance(
    const double & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__tof(
    const double & _arg)
  {
    this->tof = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> *;
  using ConstRawPtr =
    const acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__acoustic_msgs__msg__DistanceTOF
    std::shared_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__acoustic_msgs__msg__DistanceTOF
    std::shared_ptr<acoustic_msgs::msg::DistanceTOF_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DistanceTOF_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->tof != other.tof) {
      return false;
    }
    return true;
  }
  bool operator!=(const DistanceTOF_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DistanceTOF_

// alias to use template instance with default allocator
using DistanceTOF =
  acoustic_msgs::msg::DistanceTOF_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace acoustic_msgs

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__STRUCT_HPP_
