// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from acoustic_msgs:msg/DistanceTOF.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/distance_tof.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__TRAITS_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "acoustic_msgs/msg/detail/distance_tof__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace acoustic_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DistanceTOF & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: distance
  {
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << ", ";
  }

  // member: tof
  {
    out << "tof: ";
    rosidl_generator_traits::value_to_yaml(msg.tof, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DistanceTOF & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << "\n";
  }

  // member: tof
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tof: ";
    rosidl_generator_traits::value_to_yaml(msg.tof, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DistanceTOF & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace acoustic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use acoustic_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const acoustic_msgs::msg::DistanceTOF & msg,
  std::ostream & out, size_t indentation = 0)
{
  acoustic_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use acoustic_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const acoustic_msgs::msg::DistanceTOF & msg)
{
  return acoustic_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<acoustic_msgs::msg::DistanceTOF>()
{
  return "acoustic_msgs::msg::DistanceTOF";
}

template<>
inline const char * name<acoustic_msgs::msg::DistanceTOF>()
{
  return "acoustic_msgs/msg/DistanceTOF";
}

template<>
struct has_fixed_size<acoustic_msgs::msg::DistanceTOF>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<acoustic_msgs::msg::DistanceTOF>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<acoustic_msgs::msg::DistanceTOF>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__DISTANCE_TOF__TRAITS_HPP_
