// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from acoustic_msgs:msg/AhoiPacket.idl
// generated code does not contain a copyright notice
#include "acoustic_msgs/msg/detail/ahoi_packet__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
acoustic_msgs__msg__AhoiPacket__init(acoustic_msgs__msg__AhoiPacket * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    acoustic_msgs__msg__AhoiPacket__fini(msg);
    return false;
  }
  // src
  // dst
  // type
  // status
  // dsn
  // len
  return true;
}

void
acoustic_msgs__msg__AhoiPacket__fini(acoustic_msgs__msg__AhoiPacket * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // src
  // dst
  // type
  // status
  // dsn
  // len
}

bool
acoustic_msgs__msg__AhoiPacket__are_equal(const acoustic_msgs__msg__AhoiPacket * lhs, const acoustic_msgs__msg__AhoiPacket * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // src
  if (lhs->src != rhs->src) {
    return false;
  }
  // dst
  if (lhs->dst != rhs->dst) {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // dsn
  if (lhs->dsn != rhs->dsn) {
    return false;
  }
  // len
  if (lhs->len != rhs->len) {
    return false;
  }
  return true;
}

bool
acoustic_msgs__msg__AhoiPacket__copy(
  const acoustic_msgs__msg__AhoiPacket * input,
  acoustic_msgs__msg__AhoiPacket * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // src
  output->src = input->src;
  // dst
  output->dst = input->dst;
  // type
  output->type = input->type;
  // status
  output->status = input->status;
  // dsn
  output->dsn = input->dsn;
  // len
  output->len = input->len;
  return true;
}

acoustic_msgs__msg__AhoiPacket *
acoustic_msgs__msg__AhoiPacket__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AhoiPacket * msg = (acoustic_msgs__msg__AhoiPacket *)allocator.allocate(sizeof(acoustic_msgs__msg__AhoiPacket), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(acoustic_msgs__msg__AhoiPacket));
  bool success = acoustic_msgs__msg__AhoiPacket__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
acoustic_msgs__msg__AhoiPacket__destroy(acoustic_msgs__msg__AhoiPacket * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    acoustic_msgs__msg__AhoiPacket__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
acoustic_msgs__msg__AhoiPacket__Sequence__init(acoustic_msgs__msg__AhoiPacket__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AhoiPacket * data = NULL;

  if (size) {
    data = (acoustic_msgs__msg__AhoiPacket *)allocator.zero_allocate(size, sizeof(acoustic_msgs__msg__AhoiPacket), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = acoustic_msgs__msg__AhoiPacket__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        acoustic_msgs__msg__AhoiPacket__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
acoustic_msgs__msg__AhoiPacket__Sequence__fini(acoustic_msgs__msg__AhoiPacket__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      acoustic_msgs__msg__AhoiPacket__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

acoustic_msgs__msg__AhoiPacket__Sequence *
acoustic_msgs__msg__AhoiPacket__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AhoiPacket__Sequence * array = (acoustic_msgs__msg__AhoiPacket__Sequence *)allocator.allocate(sizeof(acoustic_msgs__msg__AhoiPacket__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = acoustic_msgs__msg__AhoiPacket__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
acoustic_msgs__msg__AhoiPacket__Sequence__destroy(acoustic_msgs__msg__AhoiPacket__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    acoustic_msgs__msg__AhoiPacket__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
acoustic_msgs__msg__AhoiPacket__Sequence__are_equal(const acoustic_msgs__msg__AhoiPacket__Sequence * lhs, const acoustic_msgs__msg__AhoiPacket__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!acoustic_msgs__msg__AhoiPacket__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
acoustic_msgs__msg__AhoiPacket__Sequence__copy(
  const acoustic_msgs__msg__AhoiPacket__Sequence * input,
  acoustic_msgs__msg__AhoiPacket__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(acoustic_msgs__msg__AhoiPacket);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    acoustic_msgs__msg__AhoiPacket * data =
      (acoustic_msgs__msg__AhoiPacket *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!acoustic_msgs__msg__AhoiPacket__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          acoustic_msgs__msg__AhoiPacket__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!acoustic_msgs__msg__AhoiPacket__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
