// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from acoustic_msgs:msg/AnchorPoses.idl
// generated code does not contain a copyright notice
#include "acoustic_msgs/msg/detail/anchor_poses__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `anchors`
#include "acoustic_msgs/msg/detail/anchor_pose__functions.h"

bool
acoustic_msgs__msg__AnchorPoses__init(acoustic_msgs__msg__AnchorPoses * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    acoustic_msgs__msg__AnchorPoses__fini(msg);
    return false;
  }
  // anchors
  if (!acoustic_msgs__msg__AnchorPose__Sequence__init(&msg->anchors, 0)) {
    acoustic_msgs__msg__AnchorPoses__fini(msg);
    return false;
  }
  return true;
}

void
acoustic_msgs__msg__AnchorPoses__fini(acoustic_msgs__msg__AnchorPoses * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // anchors
  acoustic_msgs__msg__AnchorPose__Sequence__fini(&msg->anchors);
}

bool
acoustic_msgs__msg__AnchorPoses__are_equal(const acoustic_msgs__msg__AnchorPoses * lhs, const acoustic_msgs__msg__AnchorPoses * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // anchors
  if (!acoustic_msgs__msg__AnchorPose__Sequence__are_equal(
      &(lhs->anchors), &(rhs->anchors)))
  {
    return false;
  }
  return true;
}

bool
acoustic_msgs__msg__AnchorPoses__copy(
  const acoustic_msgs__msg__AnchorPoses * input,
  acoustic_msgs__msg__AnchorPoses * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // anchors
  if (!acoustic_msgs__msg__AnchorPose__Sequence__copy(
      &(input->anchors), &(output->anchors)))
  {
    return false;
  }
  return true;
}

acoustic_msgs__msg__AnchorPoses *
acoustic_msgs__msg__AnchorPoses__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AnchorPoses * msg = (acoustic_msgs__msg__AnchorPoses *)allocator.allocate(sizeof(acoustic_msgs__msg__AnchorPoses), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(acoustic_msgs__msg__AnchorPoses));
  bool success = acoustic_msgs__msg__AnchorPoses__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
acoustic_msgs__msg__AnchorPoses__destroy(acoustic_msgs__msg__AnchorPoses * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    acoustic_msgs__msg__AnchorPoses__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
acoustic_msgs__msg__AnchorPoses__Sequence__init(acoustic_msgs__msg__AnchorPoses__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AnchorPoses * data = NULL;

  if (size) {
    data = (acoustic_msgs__msg__AnchorPoses *)allocator.zero_allocate(size, sizeof(acoustic_msgs__msg__AnchorPoses), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = acoustic_msgs__msg__AnchorPoses__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        acoustic_msgs__msg__AnchorPoses__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
acoustic_msgs__msg__AnchorPoses__Sequence__fini(acoustic_msgs__msg__AnchorPoses__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      acoustic_msgs__msg__AnchorPoses__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

acoustic_msgs__msg__AnchorPoses__Sequence *
acoustic_msgs__msg__AnchorPoses__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  acoustic_msgs__msg__AnchorPoses__Sequence * array = (acoustic_msgs__msg__AnchorPoses__Sequence *)allocator.allocate(sizeof(acoustic_msgs__msg__AnchorPoses__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = acoustic_msgs__msg__AnchorPoses__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
acoustic_msgs__msg__AnchorPoses__Sequence__destroy(acoustic_msgs__msg__AnchorPoses__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    acoustic_msgs__msg__AnchorPoses__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
acoustic_msgs__msg__AnchorPoses__Sequence__are_equal(const acoustic_msgs__msg__AnchorPoses__Sequence * lhs, const acoustic_msgs__msg__AnchorPoses__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!acoustic_msgs__msg__AnchorPoses__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
acoustic_msgs__msg__AnchorPoses__Sequence__copy(
  const acoustic_msgs__msg__AnchorPoses__Sequence * input,
  acoustic_msgs__msg__AnchorPoses__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(acoustic_msgs__msg__AnchorPoses);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    acoustic_msgs__msg__AnchorPoses * data =
      (acoustic_msgs__msg__AnchorPoses *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!acoustic_msgs__msg__AnchorPoses__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          acoustic_msgs__msg__AnchorPoses__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!acoustic_msgs__msg__AnchorPoses__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
