// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from acoustic_msgs:msg/AnchorPoses.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "acoustic_msgs/msg/anchor_poses.hpp"


#ifndef ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSES__TRAITS_HPP_
#define ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "acoustic_msgs/msg/detail/anchor_poses__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'anchors'
#include "acoustic_msgs/msg/detail/anchor_pose__traits.hpp"

namespace acoustic_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AnchorPoses & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: anchors
  {
    if (msg.anchors.size() == 0) {
      out << "anchors: []";
    } else {
      out << "anchors: [";
      size_t pending_items = msg.anchors.size();
      for (auto item : msg.anchors) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AnchorPoses & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: anchors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.anchors.size() == 0) {
      out << "anchors: []\n";
    } else {
      out << "anchors:\n";
      for (auto item : msg.anchors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AnchorPoses & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace acoustic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use acoustic_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const acoustic_msgs::msg::AnchorPoses & msg,
  std::ostream & out, size_t indentation = 0)
{
  acoustic_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use acoustic_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const acoustic_msgs::msg::AnchorPoses & msg)
{
  return acoustic_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<acoustic_msgs::msg::AnchorPoses>()
{
  return "acoustic_msgs::msg::AnchorPoses";
}

template<>
inline const char * name<acoustic_msgs::msg::AnchorPoses>()
{
  return "acoustic_msgs/msg/AnchorPoses";
}

template<>
struct has_fixed_size<acoustic_msgs::msg::AnchorPoses>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<acoustic_msgs::msg::AnchorPoses>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<acoustic_msgs::msg::AnchorPoses>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ACOUSTIC_MSGS__MSG__DETAIL__ANCHOR_POSES__TRAITS_HPP_
